\ On a 33 MHz '386 machine:
\ Expect: 300,000 * 1,000 * ( 4 cycles + 2 cycles ) / 33,000,000 == 54.55s.

\ On a 66 MHz '486 machine:
\ Expect: 300,000 * 1,000 * ( 1 cycle + 1 cycle ) / 66,000,000 == 9.1s.

\ On a 166 MHz P5 machine:
\ Expect: 300,000 * 1,000 * ( 1 cycle + 1 cycle ) / 166,000,000 == 3.61s.

\	eax push, eax pop,	\ $50 $58

: PARA	BEGIN HERE #16 MOD 
	WHILE $90 c,
	REPEAT ;

0 VALUE test

: P&P,		( n -- ) 0 ?DO  $50 c, $58 c, LOOP ;
: NOP,		( n -- ) 0 ?DO  $90 c, LOOP ;
: NOPS,		( n -- ) 0 ?DO  2 NOP, LOOP ;
: P&P+NOPS,	( n -- ) 0 ?DO  1 P&P, test NOP,  LOOP ;

NEEDS -assembler

CODE asmloop ( -- )
	#1000 P&P,
	ebx jmp,
END-CODE

CODE asmloop2 ( -- )
	#1000 NOPS,
	ebx jmp,
END-CODE


\ How many NOPs can be squeezed in for free?
\ This is possible when the CPU has to wait for slow memory or cache.
CODE asmloop3 ( -- )
	1 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE

CODE asmloop4 ( -- )
	2 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE

CODE asmloop5 ( -- )
	3 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE

CODE asmloop6 ( -- )
	4 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE

CODE asmloop7 ( -- )
	5 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE

CODE asmloop8 ( -- )
	6 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE

CODE asmloop9 ( -- )
	7 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE

CODE asmloop10 ( -- )
	8 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE

CODE asmloop11 ( -- )
	9 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE

CODE asmloop12 ( -- )
	#10 TO test #1000 P&P+NOPS,
	ebx jmp,
END-CODE


CODE (testcache-) ( -- )
	PARA 
	#40000000 d# ecx mov,
HERE	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache1) ( -- )
	PARA 
	#40000000 d# ecx mov,
HERE	#1 P&P,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache2) ( -- )
	PARA 
	#40000000 d# ecx mov,
HERE	#1 NOPS,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE


CODE (testcache3) ( -- )
	PARA 
	#20000000 d# ecx mov,
HERE	#2 P&P,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache4) ( -- )
	PARA 
	#20000000 d# ecx mov,
HERE	#2 NOPS,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE


CODE (testcache5) ( -- )
	PARA 
	#13333333 d# ecx mov,
HERE	#3 P&P,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache6) ( -- )
	PARA 
	#13333333 d# ecx mov,
HERE	#3 NOPS,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache7) ( -- )
	PARA 
	#10000000 d# ecx mov,
HERE	#4 P&P,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache8) ( -- )
	PARA 
	#10000000 d# ecx mov,
HERE	#4 NOPS,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache9) ( -- )
	PARA 
	#4000000 d# ecx mov,
HERE	#10 P&P,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache10) ( -- )
	PARA 
	#4000000 d# ecx mov,
HERE	#10 NOPS,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache11) ( -- )
	PARA 
	#400000 d# ecx mov,
HERE	#100 P&P,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache12) ( -- )
	PARA 
	#400000 d# ecx mov,
HERE	#100 NOPS,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache13) ( -- )
	PARA 
	#40000 d# ecx mov,
HERE	#1000 P&P,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE

CODE (testcache14) ( -- )
	PARA 
	#40000 d# ecx mov,
HERE	#1000 NOPS,
	ecx dec,
	( addr) 1 jnz,
	ebx jmp,
END-CODE


: 100,000-TIMES
	CR ." Expected time on 166 MHz P5 : 1.20 seconds,"
	CR ." Expected time on 66 MHz '486: 3.03 seconds,"
	CR ." expected time on 33 MHz '386: 18.18 seconds."
	CR TIMER-RESET #100000 0 DO asmloop  LOOP .ELAPSED ."  (push/pop)"
	CR TIMER-RESET #100000 0 DO asmloop2 LOOP .ELAPSED ."  (nop/nop)" ;

: 300,000-TIMES
	CR ." Expected time on 166 MHz P5 : 3.6 seconds,"
	CR ." Expected time on 66 MHz '486: 9.1 seconds,"
	CR ." expected time on 33 MHz '386: 54.54 seconds."
	CR TIMER-RESET #300000 0 DO asmloop  LOOP .ELAPSED ."  (push/pop)" 
	CR TIMER-RESET #300000 0 DO asmloop2 LOOP .ELAPSED ."  (nop/nop)" ;

: TEST-CACHE
	CR ." Loops executing ~40,000,000 instructions:"
	CR ." ( empty )                   " TIMER-RESET (testcache-)  .ELAPSED 
	CR ."         eax push, eax pop,  " TIMER-RESET (testcache1)  .ELAPSED 
	CR ."         nop, nop,           " TIMER-RESET (testcache2)  .ELAPSED 
	CR ."    2 * (eax push, eax pop,) " TIMER-RESET (testcache3)  .ELAPSED 
	CR ."    2 * (nop, nop,)          " TIMER-RESET (testcache4)  .ELAPSED 
	CR ."    3 * (eax push, eax pop,) " TIMER-RESET (testcache5)  .ELAPSED 
	CR ."    3 * (nop, nop,)          " TIMER-RESET (testcache6)  .ELAPSED 
	CR ."    4 * (eax push, eax pop,) " TIMER-RESET (testcache7)  .ELAPSED 
	CR ."    4 * (nop, nop,)          " TIMER-RESET (testcache8)  .ELAPSED 
	CR ."   10 * (eax push, eax pop,) " TIMER-RESET (testcache9)  .ELAPSED 
	CR ."   10 * (nop, nop,)          " TIMER-RESET (testcache10) .ELAPSED 
	CR ."  100 * (eax push, eax pop,) " TIMER-RESET (testcache11) .ELAPSED 
	CR ."  100 * (nop, nop,)          " TIMER-RESET (testcache12) .ELAPSED 
	CR ." 1000 * (eax push, eax pop,) " TIMER-RESET (testcache13) .ELAPSED 
	CR ." 1000 * (nop, nop,)          " TIMER-RESET (testcache14) .ELAPSED ;

: TEST-CONTENTION ( -- )
	CR ." Executing 10e6 {eax push, eax pop,    nop, ... nop,} on 166 MHz P5"
	CR ." No NOPs             : "
	TIMER-RESET #10000 0 DO asmloop  LOOP .ELAPSED ."  Expect: " 20e6 166e6 f/ f.
	CR ." Squeezing in 1 NOP  : "
	TIMER-RESET #10000 0 DO asmloop3 LOOP .ELAPSED ."  Expect: " 30e6 166e6 f/ f.
	CR ." Squeezing in 2 NOPs : "
	TIMER-RESET #10000 0 DO asmloop4 LOOP .ELAPSED ."  Expect: " 40e6 166e6 f/ f.
	CR ." Squeezing in 3 NOPs : "
	TIMER-RESET #10000 0 DO asmloop5 LOOP .ELAPSED ."  Expect: " 50e6 166e6 f/ f.
	CR ." Squeezing in 4 NOPs : "
	TIMER-RESET #10000 0 DO asmloop6 LOOP .ELAPSED ."  Expect: " 60e6 166e6 f/ f.
	CR ." Squeezing in 5 NOPs : "
	TIMER-RESET #10000 0 DO asmloop7 LOOP .ELAPSED ."  Expect: " 70e6 166e6 f/ f.
	CR ." Squeezing in 6 NOPs : "
	TIMER-RESET #10000 0 DO asmloop8 LOOP .ELAPSED ."  Expect: " 80e6 166e6 f/ f.
	CR ." Squeezing in 7 NOPs : "
	TIMER-RESET #10000 0 DO asmloop9 LOOP .ELAPSED ."  Expect: " 90e6 166e6 f/ f.
	CR ." Squeezing in 8 NOPs : "
	TIMER-RESET #10000 0 DO asmloop10 LOOP .ELAPSED ."  Expect: " 100e6 166e6 f/ f.
	CR ." Squeezing in 9 NOPs : "
	TIMER-RESET #10000 0 DO asmloop11 LOOP .ELAPSED ."  Expect: " 110e6 166e6 f/ f. ;

