cr .~ A classical benchmark of an O(n**2) algorithm; Bubble sort~

\ Part of the programs gathered by John Hennessy for the MIPS
\ RISC project at Stanford. Translated to forth by Marty Fraeman
\ Johns Hopkins University/Applied Physics Laboratory.

cr .( Using iForth's BOUNDS)

\ MM forth2c doesn't have it !
\ : bounds  s" over + swap" evaluate ; immediate

1 cells constant cell

variable seed ( -- addr)

: initiate-seed ( -- )  #74755 seed ! ;

: random  ( -- n )  seed @ #1309 * #13849 + #65535 and dup seed ! ;

#6000 constant #elements ( -- int )

align create list #elements cells allot

: initiate-list ( -- )
  list #elements cells BOUNDS do random i ! cell +loop ;

: dump-list ( -- )
  list #elements cells BOUNDS do i @ . cell +loop cr ;

: verify-list ( -- )
  list #elements 1- cells BOUNDS do
    i 2@ > abort" bubble-sort: not sorted"
  cell +loop ;

list =: 'list

: bubble ( -- )
  cr ." bubbling..."
  #elements 1 do
    'list #elements i - cells bounds do
\	i 2@ > if i 2@ swap i 2! then
	i 2@ > IF i 2@  i d! THEN
    cell +loop
  loop ;

: bubble-sort ( -- )
  initiate-seed
  initiate-list
  bubble
  verify-list ;

: bubble-with-flag ( -- )
  cr ." bubbling with flag..."
  #elements 1 do
    true 'list #elements i - cells bounds do
      i 2@ > if i 2@ swap i 2! drop 0 then
    cell +loop
    if leave then
  loop ;

: bubble-sort-with-flag ( -- )
  initiate-seed
  initiate-list
  bubble-with-flag
  verify-list ;

: main	( -- )
	open-log
	TIMER-RESET bubble-sort           CR .ELAPSED
	TIMER-RESET bubble-sort-with-flag CR .ELAPSED
	close-log ;

main