(*
 * LANGUAGE    : ANS Forth 
 * PROJECT     : Forth Environments
 * DESCRIPTION : Floating point performance
 * CATEGORY    : Benchmarks
 * AUTHOR      : Marcel Hendrix, August 3rd, 1991
 * LAST CHANGE : November 17th, 1991 MHX, FSINCOS => FCOS
 * LAST CHANGE : October 5th, 1991 MHX
 *)



	NEEDS -miscutil

	REVISION -float " FLOAT  speed test   Version 1.01 "



	S" EMULATED" ENVIRONMENT? AND [IF] #100 
				    [ELSE] #100000 
				    [THEN] VALUE MaxLoop

: FLOAT	CR ." Begin !!! " CR TIMER-RESET
	1234e FLOCAL a	
	23e5  FLOCAL b   
	10e   FLOCAL c 
	0e    FLOCAL x	
	0e    FLOCAL y	
	0e    FLOCAL z	
	MaxLoop FOR 
		   AFT  
		     a       TO x  
		     b       TO y
		     x y F+  c x F*  F-  y F/  TO z
		     z FCOS  TO x 
		     x FLN   TO z 
		     z FEXP  TO y 
		     y FSQRT TO x 
		  THEN
	       NEXT 
	CR .ELAPSED ;

:ABOUT	CR 
	CR ." Enter FLOAT to start this benchmark." 
	CR ." ===================================="
	CR ."           Compile time   Run time"
	CR ." ------------------------------------"
	CR ." Par.C        59.15        13.31" 
	CR ." Inmos ICC   101.83        32.40" 
	CR ." 3L C         47.51        25.19" 
	CR ." iForth        0.10         3.18 (66 MHz '486)"
	CR ." ------------------------------------"
	CR ." tForth        0.10        18.19" ;


	CR CR .ABOUT -float

				(* End FLOAT *)