(*
 * LANGUAGE    : ANS Forth 
 * PROJECT     : Forth Environments
 * DESCRIPTION : Floating point performance
 * CATEGORY    : Benchmarks
 * AUTHOR      : Marcel Hendrix, August 3rd, 1991
 * LAST CHANGE : October 5th, 1991 MHX
 *)



	      (* ****************************************** *)
	      (*					    *)
	      (*      From Dr. Dobb's Jr., Sept., 1988	    *)
 	      (*     Translated to Forth by R. L. Smith	    *)
	      (*   Adapted to F-4TH by MH, June 27th 1989   *)
	      (*      Adapted to tForth by MH, May 1991     *)
	      (*        Needs 25.98 seconds (386 @33MHz)    *)
	      (*					    *)
	      (* ****************************************** *)



	NEEDS -miscutil

	REVISION -fpmath " FPMATH speed test   Version 1.01 "

	PRIVATES


#50 =: nloops 	PRIVATE


0e FVALUE argument	PRIVATE
0e FVALUE result	PRIVATE

 0 [IF]  : .@	POSTPONE ." ; IMMEDIATE  : @CR CR ;
 [ELSE]  : .@	POSTPONE \  ; IMMEDIATE  : @CR    ;
 [THEN]


: TESTSQRT  ( -- )
        .@ Square roots   "
        nloops 0
        DO      .@ ."   
		CLEAR argument
                BEGIN
                        argument 1000e F> 0=
                WHILE
                        argument FSQRT TO result
                        1E +TO argument
                REPEAT
        LOOP ; PRIVATE


: TESTLN   ( -- )
        .@ Logs           "
        nloops 0
        DO      .@ ."   
		0.1e TO argument
                BEGIN
                        argument 1000.1e F> 0=
                WHILE
                        argument  FLN TO result
                        1E +TO argument
                REPEAT
        LOOP ; PRIVATE


: TESTEXP   ( -- )
        .@ Exponentials   "
        nloops 0
        DO      .@ ."   
		CLEAR argument
                BEGIN
                        argument 10e F> 0=
                WHILE
                        argument  FEXP TO result
                        0.01e +TO argument
                REPEAT
        LOOP ; PRIVATE


: TESTARCTAN   ( -- )
        .@ Arctans        "
        nloops 0
        DO      .@ ."   
		0.1e TO argument
                BEGIN   argument 10e F> 0=
                WHILE
                        argument FATAN TO result
                        0.01e +TO argument
                REPEAT
        LOOP ; PRIVATE

PI 360E F/ FCONSTANT pi/360	PRIVATE

: TESTSIN    ( -- )
        .@ Sines          "
        nloops 0
        DO      .@ ."   
		CLEAR argument
                BEGIN   argument PI*2 F> 0=
                WHILE
                        argument FSIN TO result
                        pi/360 +TO argument 
                REPEAT
        LOOP ; PRIVATE

: FPMATH   	CR TIMER-RESET		\ <> --- <>
		  TESTSQRT   @CR
		  TESTLN     @CR
		  TESTEXP    @CR
		  TESTARCTAN @CR
		  TESTSIN    @CR
		.ELAPSED ;

:ABOUT		CR 
		CR ." Enter FPMATH to test (nloops = " nloops 0 .R ." )."
		CR ." [Needs 259.80 seconds on 33 Mhz '386 w/o '387]" 
		CR ." [Needs 2.240 seconds on 66 MHz '486]" ;


		DEPRIVE

		.ABOUT -fpmath  CR

			    (* End of Source *)