\ NOTE: This version needs 0.5MB data space

cr .~ A classical benchmark of an O(n**3) algorithm; Matrix Multiplication~

\ Part of the programs gathered by John Hennessy for the MIPS
\ RISC project at Stanford. Translated to forth by  Marty Fraeman,
\ Johns Hopkins University/Applied Physics Laboratory.

\ MM forth2c doesn't have it !
\ : bounds  over + swap ;

variable seed

: initiate-seed ( -- )  74755 seed ! ;
: random  ( -- n )  seed @ 1309 * 13849 + 65535 and dup seed ! ;

1 cells constant cell
200 constant row-size
row-size cells constant row-byte-size

row-size row-size * constant mat-size
mat-size cells constant mat-byte-size

mat-byte-size allocate ?allocate  constant ima
mat-byte-size allocate ?allocate  constant imb
mat-byte-size allocate ?allocate  constant imr

: initiate-matrix ( m[row-size][row-size] -- )
  mat-byte-size bounds do
    random dup #120 / #120 * - #60 - i !
  cell +loop
;

0 [IF]
: innerproduct ( a[row][*] b[*][column] -- int)
  0 row-size 0 do
    >r over @ over @ * r> + >r
    cell+ swap row-byte-size + swap
    r>
  loop
  >r 2drop r>
;
[ELSE]
: innerproduct ( a[row][*] b[*][column] -- int)
  0 >S
  row-size CELLS bounds do
    dup @  I @  * S+!
    row-byte-size +
  cell +loop
  drop S> ;
[THEN]

: main  ( -- )
  open-log cr ." Matrix multiply in progress.."
  timer-reset
  initiate-seed
  ima initiate-matrix
  imb initiate-matrix
  imr ima mat-byte-size bounds do
    imb row-byte-size bounds do
      j i innerproduct over ! cell+
    cell +loop
  row-size cells +loop
  drop
  cr .elapsed
  close-log ;

 main
