(*
 * LANGUAGE    : ANS Forth 
 * PROJECT     : Forth Environments
 * DESCRIPTION : Block moves in main memory
 * CATEGORY    : Benchmarks
 * AUTHOR      : Marcel Hendrix, August 3rd, 1991
 * LAST CHANGE : October 5th, 1991 MHX
 *)



	NEEDS -miscutil

 	REVISION -movspeed " MOVE speed testing  Version 1.00 "

	PRIVATES				       


#300000 =: #buf		PRIVATE

0 VALUE 'buffer1	PRIVATE
0 VALUE 'buffer2	PRIVATE


: SET-UP	#buf 1+ ALLOCATE THROW  TO 'buffer1
		#buf 1+ ALLOCATE THROW  TO 'buffer2
		TIMER-RESET ; PRIVATE

: CLEAN-UP	#buf 50 *  ?MS timer0 @ -	\ <addr> --- <>
		CR ROT COUNT TYPE
		DUP ." 15000 Kbyte transferred in " DEC. ." ms, "
		    / 0 .R ."  kBytes/second" 
		'buffer1 FREE THROW 
		'buffer2 FREE THROW ; PRIVATE



: TEST-CMOVE	SET-UP
		#49 FOR  'buffer1 'buffer2 #buf CMOVE  NEXT
		C" CMOVE     : " CLEAN-UP ; PRIVATE


: TEST-CMOVE> 	SET-UP
		#49 FOR  'buffer2 'buffer1 #buf CMOVE> NEXT
		C" CMOVE>    : " CLEAN-UP ; PRIVATE


: TEST-MOVE> 	SET-UP
		#49 FOR  'buffer1 'buffer2 #buf MOVE   NEXT
		C" MOVE 1->2 : " CLEAN-UP ; PRIVATE


: TEST-<MOVE	SET-UP
		#49 FOR  'buffer2 'buffer1 #buf MOVE   NEXT
		C" MOVE 2<-1 : " CLEAN-UP ; PRIVATE

-- Overlapping moves.

: TEST-OCMOVE	SET-UP
		#49 FOR  'buffer1 'buffer1 1+ #buf CMOVE  NEXT
		C" CMOVE     : " CLEAN-UP ; PRIVATE


: TEST-OCMOVE> 	SET-UP
		#49 FOR  'buffer1 1+ 'buffer1 #buf CMOVE>  NEXT
		C" CMOVE>    : " CLEAN-UP ; PRIVATE


: TEST-OMOVE> 	SET-UP
		#49 FOR  'buffer1 'buffer1 1+ #buf MOVE  NEXT
		C" MOVE 1->2 : " CLEAN-UP ; PRIVATE


: TEST-<OMOVE	SET-UP
		#49 FOR  'buffer1 1+ 'buffer1 #buf MOVE  NEXT
		C" MOVE 2<-1 : " CLEAN-UP ; PRIVATE


: TEST-MOVES	CR CR ." Non-overlapping buffers..." CR

		TEST-CMOVE
		TEST-CMOVE>
		TEST-MOVE>
		TEST-<MOVE

		CR CR ." Overlapping buffers...(may take a few minutes)..." CR

		TEST-OCMOVE
		TEST-OCMOVE>
		TEST-OMOVE>
		TEST-<OMOVE ;

:ABOUT 		CR ." Enter  TEST-MOVES  to check how fast Forth is at memory block moves."
		CR ." Note: No machine-specific instructions are used." 
		CR ." A 50 MHz i486 fetches 11.8 MByte/s on this test."
		CR ;

		DEPRIVE

		.ABOUT -movspeed CR

				(* End MOVSPEED *)