(*
 * LANGUAGE    : ANS Forth 
 * PROJECT     : Forth Environments
 * DESCRIPTION : Savage
 * CATEGORY    : Benchmarks
 * AUTHOR      : Marcel Hendrix
 * LAST CHANGE : August 1, 1993 MHX, more loops to increase timing accuracy
 * LAST CHANGE : October 5th, 1991 MHX
 *)


	NEEDS -miscutil

	REVISION -savage " SAVAGE speed test   Version 2.00 "


#2500 VALUE MaxLoop

	
: (SAVAGE)	\ F: <> --- <r>
	1e 
	MaxLoop 1- 0	( Do 2499 times for result of 2500 ) 
	 ?DO
	    FSQR  FSQRT 	\ 93 ms, zero error
	    FLN   FEXP
	    FATAN FTAN 		\ most errors are in here !!
	    F1+ 
	LOOP ;


: SAVAGE
	CR ." Testing . . " TIMER-RESET
	0e  #100 0 DO FDROP (SAVAGE) LOOP 
	CR (.T0) 2DROP diff0 @ #100 / U. ."  milliseconds per iteration." 
	CR ." Error = "  MaxLoop S>F F- +E. ;


:ABOUT	CR ." On a 12.5 Mhz '286 TP5.0/4.0/3.0 takes 23.0 seconds, error 1E-12."
	CR ." On a 33 MHz '386 the Pascal timing is 5.0 seconds, using doubles."
	CR ."     Par.C               0.310       +3.1636e-07"
	CR ."     Inmos ICC           0.833       -1.17773e-09"
	CR ."     3L C                0.633       -1.17779e-09"
	CR ."     tForth T8 20 MHz    0.569        1.56e-9"
	CR ."     iForth '486 50 MHz  0.099       -6.9e-13"
	CR ."     iForth P5 166 MHz   0.018       -6.9e-13"
	CR CR ." Enter SAVAGE to run the benchmark." ;
	
	.ABOUT -savage CR 	

			  (* End of Source *)